



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【OpenCV】基于kmeans的细胞检测方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【OpenCV】基于kmeans的细胞检测方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 08:01:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>问题是这样的，有一幅经过二值化处理之后的图像，我们希望统计其中细胞的个数，和不同粘连情况的细胞个数，比如，下图中有1个细胞组成连通区域的，也有2个细胞组成连通区域的，也有更多个细胞组成连通区域的，我们希望分别统计不同的情况。</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20131215205141593" /></div>
<div>我想出的一种可行的方法是这样的：</div>
<div>
<ol><li>通过图像形态学的处理erode，将一些邻接的细胞分离开来，并减少单个像素的噪声干扰</li>
<li>计算其中的连通域</li>
<li>计算每一个连通域的面积</li>
<li>根据面积计算其中的聚类，其中聚类算法采用kmeans，其中k，由用户设定</li>
<li>根据聚类的情况计算其中细胞数</li></ol>
</div>
<div> 
 </div>
<div>
  里面的采用聚类的思想是根据不同类型的重叠细胞，其中的面积应该有相应的分布，比如，两个重叠的细胞面积往往会显著的小于三个重叠的细胞（但是肯定会有例外），我们基于以上的想法通过计算聚类的方法计算其中的细胞数。
 </div>
<div>
<pre class="prettyprint linenums">import cv2<br />
from numpy import *<br />
from scipy.cluster.vq import *

img=cv2.imread('FigProb9.27.jpg',0)<br />
kernel=cv2.getStructuringElement(cv2.MORPH_CROSS,(3,3))<br />
img=cv2.erode(img,kernel,iterations=5)<br />
contour,h=cv2.findContours(img,cv2.RETR_EXTERNAL,cv2.CHAIN_APPROX_NONE)<br />
cv2.drawContours(img,contour,-1,(255,0,0),1)<br />
cv2.imshow('img',img)

ContourArea=[]<br />
for cnt in contour:<br />
    Area=cv2.contourArea(cnt)<br />
    ContourArea.append(Area)<br />
ContourArea=array(ContourArea)<br />
ContourArea=ContourArea[ContourArea&gt;20]<br />
#print len(ContourArea)<br />
# print ContourArea<br />
# print min(ContourArea)<br />
# print max(ContourArea)<br />
# print average(ContourArea)<br />
#print sort(ContourArea)<br />
centroid,dis=kmeans(ContourArea,5)#calculate 5 cluster<br />
label,dis=vq(ContourArea,sort(centroid))#calculate label in 5 cluster<br />
clusterNum=[]#the amount cluster<br />
classNum=[]#the total amount cell in this kind of cluster<br />
for i in range(len(label)):<br />
    clusterNum.append(len(label[label==i]))<br />
    classNum.append(clusterNum[i]*(i+1))

print ("In picture,we can see Total amount of cell is %d.\n ")%(sum(classNum))<br />
print("%d in one;%d in two;%d in three;%d in four;%d in five.")%(classNum[0],classNum[1],classNum[2],classNum[3],classNum[4])<br />
cv2.waitKey()
</pre></p></div>
<div>
  <br /> 
 </div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv67y8x.html">&lbrack;译&rsqb;Godot系列教程五 - 制作Godot编辑器插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/495p1gmq.html">UWP 下拉刷新控件（PullToRefreshControl）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q72d0k9.html">近期C&num;项目中总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/390ze4jq.html">QuickFIX&sol;J常见问题汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqly3e19.html">POJ 2185  Milking Grid KMP（矩阵循环节）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12r5g8.html">cookie标准话</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnpn0e8.html">BestCoder Round &num;20 部分题解&lpar;A&comma;B&comma;C&rpar;&lpar;hdu5123&comma;5124&comma;5125&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzx1xg8.html">Qwt安装（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k2o359.html">Gsp</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp30d59.html">多台CentOS服务器下实现SSH免密码登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gzrvzq.html">&lbrack;Centos7&rsqb;无法访问配置好的nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjwdjr9.html">Zookeeper C&plus;&plus;编程实战之配置更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/8komjw3q.html">Data Guard 主备库角色转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp6gn49.html">wamp5多站点配置教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/953erpm8.html">Sharepoint安装的几处注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx21k1d8.html">springmvc&plus;hibernate4事务管理配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnony4q.html">内功心法 -- java&period;util&period;LinkedList&amp;lt&semi;E&amp;gt&semi; &lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4zwxm8.html">nginx配置Strict Transport Security</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44ymk0q.html">如何让Beamer的logo放在右上角</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77g45eq.html">redis memcache rabbitMQ</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e17r7e9.html">3D 服务器端以向量计算为主的角色位置的算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1k4xk8.html">linux的getcwd和readlink的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y26geq.html">citrix xen server 虚拟机无法关闭的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1kl138.html">linux中轻松使用backspace和上下按键</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y2623q.html">IEnumerable&comma;ICollection&comma;IList&comma;List区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/96okgk39.html">破解EXCEL2007的密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/96okk5v9.html">Java精确计算</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xvv6z8.html">由tomcat启动想到的</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd3pv48.html">网页增重不可控？试试 OneAPM Cloud Test</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1znx569.html">PHP 文件上传注意一个地方，移动文件时要保证目标目录存在，否则报错</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
